Package: org.grails.cli.profile

## [Groovy] Class AbstractProfile

- org.grails.cli.profile.AbstractProfile

- All Implemented Interfaces and Traits:
    Profile

      @groovy.transform.CompileStatic
      @groovy.transform.ToString(includes = ['name'])
      abstract class AbstractProfile
      extends java.lang.Object

  Abstract implementation of the profile class

  Authors:
    Graeme Rocher
  Since:
    3.1

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected java.util.List<java.lang.String>` | `binaryExtensions` |
    `protected java.util.List<java.lang.String>` | `buildExcludes` |
    `protected java.util.List<java.lang.String>` | `buildMerge` |
    `protected java.util.List<java.lang.String>` | `buildPlugins` |
    `protected java.util.List<java.lang.String>` | `buildRepositories` |
    `protected java.lang.ClassLoader` | `classLoader` |
    `protected java.util.Map<java.lang.String, Command>` | `commandsByName` |
    `protected java.util.Set<java.lang.String>` | `defaultFeaturesNames` |
    `protected java.util.List<org.eclipse.aether.graph.Dependency>` | `dependencies` |
    `protected java.lang.String` | `description` |
    `protected org.eclipse.aether.util.graph.selector.ExclusionDependencySelector` | `exclusionDependencySelector` |
    `protected java.util.List<java.lang.String>` | `executablePatterns` |
    `protected java.util.List<Feature>` | `features` |
    `protected java.lang.String` | `instructions` |
    `protected java.util.List<Command>` | `internalCommands` |
    `protected java.lang.String` | `name` |
    `protected NavigableMap` | `navigableConfig` |
    `protected java.util.List<java.lang.String>` | `parentNames` |
    `protected java.util.List<Profile>` | `parentProfiles` |
    `protected java.lang.String` | `parentTargetFolder` |
    `protected Resource` | `profileDir` |
    `protected ProfileRepository` | `profileRepository` |
    `protected java.util.List<java.lang.String>` | `repositories` |
    `protected java.util.Set<java.lang.String>` | `requiredFeatureNames` |
    `protected java.util.List<java.lang.String>` | `skeletonExcludes` |
    `protected java.lang.String` | `version` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `AbstractProfile (Resource profileDir)`
    `AbstractProfile (Resource profileDir, java.lang.ClassLoader classLoader)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `java.util.Set<java.lang.String>` | `getBinaryExtensions()`
    `` | `java.util.List<java.lang.String>` | `getBuildMergeProfileNames()`
    `` | `java.util.List<java.lang.String>` | `getBuildPlugins()`
    `` | `java.util.List<java.lang.String>` | `getBuildRepositories()`
    `` | `Command` | `getCommand(ProjectContext context, java.lang.String name)`
    `` | `java.lang.Iterable<Command>` | `getCommands(ProjectContext context)`
    `` | `java.lang.Iterable<jline.console.completer.Completer>` | `getCompleters(ProjectContext context)`
    `` | `NavigableMap` | `getConfiguration()`
    `` | `java.lang.Iterable<Feature>` | `getDefaultFeatures()`
    `` | `java.util.List<org.eclipse.aether.graph.Dependency>` | `getDependencies()`
    `` | `java.lang.String` | `getDescription()`
    `` | `java.util.Set<java.lang.String>` | `getExecutablePatterns()`
    `` | `java.lang.Iterable<Profile>` | `getExtends()`
    `` | `java.lang.Iterable<Feature>` | `getFeatures()`
    `` | `java.lang.String` | `getInstructions()`
    `` | `java.lang.String` | `getParentSkeletonDir()`
    `` | `java.io.File` | `getParentSkeletonDir(java.io.File parent)`
    `` | `Resource` | `getProfileDir()`
    `` | `ProfileRepository` | `getProfileRepository()`
    `` | `java.util.List<java.lang.String>` | `getRepositories()`
    `` | `java.lang.Iterable<Feature>` | `getRequiredFeatures()`
    `` | `java.util.List<java.lang.String>` | `getSkeletonExcludes()`
    `` | `Resource` | `getTemplate(java.lang.String path)`
    `` | `java.lang.String` | `getVersion()`
    `` | `boolean` | `handleCommand(ExecutionContext context)`
    `` | `boolean` | `hasCommand(ProjectContext context, java.lang.String name)`
    `` | `protected void` | `initialize()`
    `` | `protected void` | `registerParentCommands(ProjectContext context, java.lang.Iterable<Profile> parents, groovy.lang.Closure registerCommand)`
    `` | `void` | `setProfileRepository(ProfileRepository profileRepository)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Field Detail

    - #### protected java.util.List<java.lang.String> binaryExtensions

    - #### protected java.util.List<java.lang.String> buildExcludes

    - #### protected java.util.List<java.lang.String> buildMerge

    - #### protected java.util.List<java.lang.String> buildPlugins

    - #### protected java.util.List<java.lang.String> buildRepositories

    - #### protected final java.lang.ClassLoader classLoader

    - #### protected java.util.Map<java.lang.String, Command> commandsByName

    - #### protected java.util.Set<java.lang.String> defaultFeaturesNames

    - #### protected java.util.List<org.eclipse.aether.graph.Dependency> dependencies

    - #### protected java.lang.String description

    - #### protected org.eclipse.aether.util.graph.selector.ExclusionDependencySelector exclusionDependencySelector

    - #### protected java.util.List<java.lang.String> executablePatterns

    - #### protected java.util.List<Feature> features

    - #### protected java.lang.String instructions

    - #### protected final java.util.List<Command> internalCommands

    - #### protected java.lang.String name

    - #### protected NavigableMap navigableConfig

    - #### protected java.util.List<java.lang.String> parentNames

    - #### protected java.util.List<Profile> parentProfiles

    - #### protected java.lang.String parentTargetFolder

    - #### protected final Resource profileDir

    - #### protected ProfileRepository profileRepository

    - #### protected java.util.List<java.lang.String> repositories

    - #### protected java.util.Set<java.lang.String> requiredFeatureNames

    - #### protected java.util.List<java.lang.String> skeletonExcludes

    - #### protected java.lang.String version

  - ### Constructor Detail

    - #### AbstractProfile(Resource profileDir)

    - #### AbstractProfile(Resource profileDir, java.lang.ClassLoader classLoader)

  - ### Method Detail

    - #### java.util.Set<java.lang.String> getBinaryExtensions()

    - #### @java.lang.Override java.util.List<java.lang.String> getBuildMergeProfileNames()

    - #### @java.lang.Override java.util.List<java.lang.String> getBuildPlugins()

    - #### @java.lang.Override java.util.List<java.lang.String> getBuildRepositories()

    - #### @java.lang.Override Command getCommand(ProjectContext context, java.lang.String name)

    - #### @java.lang.Override java.lang.Iterable<Command> getCommands(ProjectContext context)

    - #### @java.lang.Override java.lang.Iterable<jline.console.completer.Completer> getCompleters(ProjectContext context)

    - #### @java.lang.Override NavigableMap getConfiguration()

    - #### @java.lang.Override java.lang.Iterable<Feature> getDefaultFeatures()

    - #### java.util.List<org.eclipse.aether.graph.Dependency> getDependencies()

    - #### java.lang.String getDescription()

    - #### java.util.Set<java.lang.String> getExecutablePatterns()

    - #### @java.lang.Override java.lang.Iterable<Profile> getExtends()

    - #### @java.lang.Override java.lang.Iterable<Feature> getFeatures()

    - #### java.lang.String getInstructions()

    - #### @java.lang.Override java.lang.String getParentSkeletonDir()

    - #### @java.lang.Override java.io.File getParentSkeletonDir(java.io.File parent)

    - #### Resource getProfileDir()

    - #### ProfileRepository getProfileRepository()

    - #### @java.lang.Override java.util.List<java.lang.String> getRepositories()

    - #### @java.lang.Override java.lang.Iterable<Feature> getRequiredFeatures()

    - #### java.util.List<java.lang.String> getSkeletonExcludes()

    - #### @java.lang.Override Resource getTemplate(java.lang.String path)

    - #### java.lang.String getVersion()

    - #### @java.lang.Override boolean handleCommand(ExecutionContext context)

    - #### @java.lang.Override boolean hasCommand(ProjectContext context, java.lang.String name)

    - #### protected void initialize()

    - #### protected void registerParentCommands(ProjectContext context, java.lang.Iterable<Profile> parents, groovy.lang.Closure registerCommand)

    - #### void setProfileRepository(ProfileRepository profileRepository)